# -*- coding: utf-8 -*-
from __future__ import print_function
import os, sys
import oss2


def percentage(consumed_bytes, total_bytes):
    if total_bytes:
        rate = int(100 * (float(consumed_bytes) / float(total_bytes)))
        print('\r{0}% '.format(rate), end=saveFile)

        sys.stdout.flush()
 

if ( len(sys.argv) > 5 ):
    AccessKeyId     = sys.argv[1]
    AccessKeySecret = sys.argv[2]
    Endpoint        = sys.argv[3] 
    Bucket          = sys.argv[4]
    fileName = sys.argv[5]
    try:
        saveFile = sys.argv[6] + fileName
    except:
        saveFile = '.' + fileName
else:
    print("Example: %s AccessKeyId AccessKeySecret Endpoint Bucket /data/backup.zip" % sys.argv[0])
    exit()
auth = oss2.Auth(AccessKeyId , AccessKeySecret)
bucket = oss2.Bucket(auth,  Endpoint, Bucket)

oss2.resumable_download(bucket, fileName, saveFile,
  store=oss2.ResumableDownloadStore(root='/tmp'),
  multiget_threshold=20*1024*1024,
  part_size=10*1024*1024,
  num_threads=5,progress_callback=percentage)

print('\rDownload %s to %s Success!' % ( fileName, saveFile))
